
%if 0

SHUFHOOK
 2021 by C. Masloch

Usage of the works is permitted provided that this
instrument is retained with the works, so that any entity
that uses the works is notified of this instrument.

DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.

%endif

	%assign __lMACROS1_MAC__DEBUG_DEFAULTS	1
%include "lmacros3.mac"
%include "AMIS.MAC"

	defaulting

	numdef UPXPAD, 0		; pad executable to >=3062 bytes for UPX

		; Option flags (hold in bp)
_bubble		equ 1
_preserve	equ 2
_normal		equ 4
_complex	equ 8
_matchmcbname	equ 40h
_matchsegment	equ 80h
_setints	equ 100h
_all		equ 200h
_fromall	equ 400h


%ifdef _MAP
	[map all _MAP]
%endif

	cpu 8086
	org 100h


transient:
			; This is a simple MS-DOS 1.x detection (8 Byte).
	mov ah, 4Dh		; the only function I found that doesn't need much setup or cleanup
	stc			; but that uses MS-DOS 2.x error reporting. clears CF (Int21.30 does not)
	int 21h
	jnc .dosgood		; it is MS-DOS 2.x+ or compatible -->
	retn			; it isn't so simply terminate
.dosgood:
	cld
	mov dx, msg.name
	call disp_msg		; Start with message

			; The UMB link and memory allocation strategy is now always safed here
			; and restored by abort_msg as well as any other termination code. This
			; saves any code changing the strategy the effort to restore it proper.
	mov ax, 5802h
	int 21h
	xor ah, ah		; some "DOS" only return al
	mov word [ restored.umblink ], ax	; save UMB link

	mov ax, 5800h
	int 21h
	mov word [ restored.strategy ], ax	; save strategy

	mov dx, i23
	mov ax, 2523h
	int 21h			; set Int23 so that we restore link/strategy on Ctrl-C as well
	mov dx, i24
	mov ax, 2524h
	int 21h			; set Int24 so all hard errors are changed to the soft error

getfirstmcb:
	mov ah, 52h
	int 21h
	mov ax, word [ es:bx - 2 ]
	mov word [firstmcb], ax

getfirstumcb:
			; We try to get the first UMCB for various uses later. Note that we
			; never use the result as an MCB address so if it's wrong we won't
			; crash or something. (We compare memory block or MCB addresses to
			; the value to check whether they're in the UMA.)
	mov ax, 1261h		; PTS-DOS: Get first UMCB
	stc
	int 2Fh
	jc .determine		; not supported -->
	inc ax
	cmp ax, byte 2		; -1, 0, 1 ?
	jbe .determine		; not supported (or none) -->
	dec ax
	mov word [ firstumcb ], ax	; set UMB
	jmp short .got		; got it -->

.determine:
	mov ax, 5803h
	xor bx, bx
	int 21h			; disable UMB link, leave only LMA chain
	jc .none		; that isn't supported either -->

	mov ax, word [firstmcb]
	mov dx, ax		; first MCB
	xor bx, bx		; use offsets from bx, not addresses
.looplmb:
	mov ds, ax
	inc ax
	add ax, word [ bx + 3 ]	; next MCB's address
	cmp byte [ bx ], 'M'
	je .looplmb		; not last -->
	cmp byte [ bx ], 'Z'
	jne .none		; corrupted -->
	xchg ax, dx		; dx = what we assume to be the first UMA chain MCB
				; ax = first MCB

	push ax
	inc bx			; = 1
	mov ax, 5803h
	int 21h			; enable UMB link, include UMA chain
	pop ax
	jc .none		; so we can disable it but not enable? -->

	dec bx			; = 0
	xor cx, cx		; flag if assumed first UMCB found
.loopumb:
	cmp ax, dx
	jne .notlastlmb
	inc cx			; there it is
.notlastlmb:
	mov ds, ax
	cmp byte [ bx ], 'M'
	jne .islastumb?		; last or corrupted -->
	inc ax
	add ax, word [ bx + 3 ]
	jmp short .loopumb	; process next -->
.islastumb?:
	cmp byte [ bx ], 'Z'
	jne .none		; corrupted -->
	jcxz .none		; didn't find that UMCB -->
			; The MCB at dx which was behind the one that contained the 'Z'
			; signature when we disabled the UMB link is now a valid MCB in
			; the MCB chain after we enabled the UMB link. All previous MCBs
			; are now 'M'.
	mov word [ cs:firstumcb ], dx
.none:
.got:
				; no need to restore es here since we do that below
				; no need to restore ds since we set it below

scancl:			; bp = selected options
	xor bp, bp		; initial option flags

	push cs
	pop es
	push cs
	pop ds			; ds, es changed while searching UMCB
	mov si, 81h		; PSP command line
.loop:	lodsb
	cmp al, 9		; tab ?
	je .loop
	cmp al, 32		; blank ?
	je .loop
	jb .end			; zero, cr, lf ? -->
	cmp al, '-'
	je .switch
	cmp al, '/'
	je .switch
	call capitalise
	cmp al, "A"
	jne @F
	mov bx, word [si]
	and bx, ~2020h
	cmp bx, "LL"
	jne @F
	or bp, _all
	inc si
	inc si
	jmp .loop

@@:
	call getnybble
	jc .invalid
	xor bx, bx
	mov bl, al
	lodsb
	call getnybble
	jc .check_end_number
	add bx, bx
	add bx, bx
	add bx, bx
	add bx, bx
	add bl, al
	lodsb
.check_end_number:
	cmp al, 9
	je @F
	cmp al, 32
	ja .invalid
@@:

.number:
	dec si
	mov al, bl
	call bx_intnum_to_dh_bx_intsel

	mov di, invalidinterrupts
	mov cx, invalidinterrupts_size
	repne scasb
	jne @F
	mov dx, msg.invalid_interrupt_1
	call disp_msg
	call disp_al_hex
	mov dx, msg.invalid_interrupt_2
	jmp abort_msg

@@:
	test byte [selectedinterrupts + bx], dh
	jz @F
	mov dx, msg.double_interrupt_1
	call disp_msg
	call disp_al_hex
	mov dx, msg.double_interrupt_2
	jmp abort_msg

@@:
	or byte [selectedinterrupts + bx], dh
	or bp, _setints
	jmp .loop


			; parse switch
.switch:
	lodsb			; get next character
	call capitalise
			; check against known switches
	cmp al, 'L'
	je .lengthnumber
	push si
	mov si, parameters
	xchg al, ah
.loopswitch:
	lodsb
	xchg ax, cx
	lodsb
	xchg ax, cx		; cx = option flags
	cmp al, 0FFh
	je .invalid		; not found!
	cmp al, ah
	jne .loopswitch		; try next -->
	pop si
	xor ch, ch
	or bp, cx
	test cl, _matchsegment
	jnz .parametersegment
	test cl, _matchmcbname
	jnz .parametermcbname
	jmp .loop		; ds:si-> character after switch character. just continue

.parametersegment:
	or word [matchoffset], -1
	lodsb
	cmp al, '='
	je @FF
	cmp al, ':'
	je @FF

	db __TEST_IMM8
@@:
	lodsb
	cmp al, 9
	je @B
	cmp al, 32
	je @B
	jb .invalid

	db __TEST_IMM8
@@:
	lodsb
	call getnybble
	jc .invalid
	xor bx, bx
	mov bl, al
@@:
	lodsb
	call getnybble
	jc .check_end_segment_number
	add bx, bx		; * 2
	jc .invalid
	add bx, bx		; * 4
	jc .invalid
	add bx, bx		; * 8
	jc .invalid
	add bx, bx		; * 16
	jc .invalid
	add bl, al
	adc bh, 0
	jc .invalid
	jmp @B
.check_end_segment_number:
	mov word [matchsegment], bx
	cmp al, ':'
	je .parameteroffset
	cmp al, 9
	je @F
	cmp al, 32
	ja .invalid
@@:

	dec si
	jmp .loop

.parameteroffset:
	lodsb
	call getnybble
	jc .invalid
	xor bx, bx
	mov bl, al
@@:
	lodsb
	call getnybble
	jc .check_end_offset_number
	add bx, bx		; * 2
	jc .invalid
	add bx, bx		; * 4
	jc .invalid
	add bx, bx		; * 8
	jc .invalid
	add bx, bx		; * 16
	jc .invalid
	add bl, al
	adc bh, 0
	jc .invalid
	jmp @B
.check_end_offset_number:
	cmp al, 9
	je @F
	cmp al, 32
	ja .invalid
@@:

	dec si
	mov word [matchoffset], bx
	jmp .loop


.lengthnumber:
	lodsb
	cmp al, '='
	je @FF
	cmp al, ':'
	je @FF

	db __TEST_IMM8
@@:
	lodsb
	cmp al, 9
	je @B
	cmp al, 32
	je @B
	jb .invalid

	db __TEST_IMM8
@@:
	lodsb
	call capitalise
	cmp al, "M"
	jne @F
	mov bx, word [si]
	and bx, ~2020h
	cmp bx, "AX"
	jne @F
	or word [lengthnumber], -1
	inc si
	inc si
	jmp .loop

@@:
	call getdecit
	jc .invalid
	xor bx, bx
	mov bl, al
@@:
	lodsb
	call getdecit
	jc .check_end_length_number
	mov cx, bx
	add bx, bx		; * 2
	jc .invalid
	add bx, bx		; * 4
	jc .invalid
	add bx, cx		; * 5
	jc .invalid
	add bx, bx		; * 10
	jc .invalid
	add bl, al
	adc bh, 0
	jc .invalid
	jmp @B
.check_end_length_number:
	cmp al, 9
	je @F
	cmp al, 32
	ja .invalid
@@:

	dec si
	test bx, bx
	jz .invalid
	mov word [lengthnumber], bx
	jmp .loop


.parametermcbname:
	lodsb
	cmp al, '='
	je @FF
	cmp al, ':'
	je @FF

	db __TEST_IMM8
@@:
	lodsb
	cmp al, 9
	je @B
	cmp al, 32
	je @B
	jb .invalid

	db __TEST_IMM8		; (skip lodsb)
@@:
	lodsb			; get next byte after equals sign
	lea di, [si - 1]	; -> re-used as buffer for MCB name
	mov word [matchmcbname], di
	mov ah, 0		; initialise ah = 0
				; al = potential quotemark
	cmp al, '"'		; is it a quotemark ?
	je @F			; yes -->
	cmp al, "'"
	jne @FF			; no -->
@@:
	mov ah, al		; save quotemark flag
	lodsb			; get first actual name byte
@@:
	db __TEST_IMM16		; have first byte already, skip stosb/lodsb
@@:
	stosb			; store next non-terminator name byte
	lodsb			; load next name byte or terminator
	call capitalise		; normalise name bytes
	test al, al		; zero ?
	jz @FF			; handle as EOL -->
	cmp al, ah		; closing quote mark ?
	je @F			; end of name -->
	cmp al, 32		; blank, tab, CR, LF ?
	ja @B			; no, is next name byte, store it -->
	test ah, ah		; got regular terminator, are we quoted ?
	jz @F			; no, handle as terminator in any case -->
	cmp al, 9		; is it a quoted tab ?
	je @B
	cmp al, 32		; is it a quoted blank ?
	je @B			; yes, so loop -->
@@:
	cmp al, ah		; quote mark closed ?
	je @FF			; yes, load next from si -> after closing quotemark
@@:
	dec si			; else: reload terminator byte in .loop
	test ah, ah		; expected closing quotemark ?
	jnz .invalid		; yes, invalid to end up here -->
@@:
	mov word [matchmcbname_end], di
	cmp di, word [matchmcbname]
	je .invalid		; yes, invalid -->
	jmp .loop


.invalid:			; display help if invalid
	mov dx, msg.help
	jmp abort_msg


.end:
	mov di, word [matchmcbname_end]
	mov al, 0
	stosb			; terminate


findinstalleddebugger:
	mov ah, 0FFh		; start with multiplex number 0FFh
.loop:
	call .check
	mov al, 30h		; al = 30h to indicate found, ah = multiplex number
	jnc .end
	sub ah, 1		; search is backward (to find latest installed first), from 0FFh to 00h including
	jnc .loop		; try next if we didn't check all yet -->

	xor ax, ax		; al = 0 to indicate none found
	jmp .end		;  If not found, continue -->


		; INP:	ah = multiplex number to check
		;	ds = ss = cs
		; OUT:	CY if multiplex number unused or no signature match,
		;	 bp, ah, ds unmodified
		;	NC if match found,
		;	 ah = multiplex number (unmodified)
		; CHG:	si, di, es, cx, dx
.check:
	mov al, 00h		; AMIS installation check
	int 2Dh			; AMIS (or "DOS reserved" = iret if no AMIS present)
	cmp al, 0FFh
	jne .notfound
	mov si, debuggeramissig	; ds:si -> our AMIS name strings
	mov es, dx		; es:di -> name strings of AMIS multiplexer that just answered
	mov cx, 8		; Ignore description, only compare vendor and program name
	repe cmpsw
	je .checkret		; ZR, NC = match -->
.notfound:
	stc			; NZ, CY no match
.checkret:
	retn

.end:
	mov word [debuggerfunction], ax


process:
	mov bx, 1
	mov ax, 5803h
	int 21h			; enable UMB link, include UMA chain
				; (needed for getmcbname)

	test bp, _bubble
	jnz bubble
	mov dx, msg.noop
	jmp abort_msg

bubble:
	mov dx, msg.bubble.signon
	call disp_msg

	test bp, _setints | _all
	jz .noint
	test bp, _matchsegment | _matchmcbname
	jz .noseg

	xor cx, cx
	push cx
	push cx
.loop:
	push cx
	mov bx, cx
	call bx_intnum_to_dh_bx_intsel
	pop cx
	and bp, ~ _fromall
	test byte [cs:selectedinterrupts + bx], dh
	jnz .callspecific
	test bp, _all
	jz .next
	xchg ax, cx
	 push cs
	 pop es
	mov di, invalidinterrupts
	mov cx, invalidinterrupts_size
	repne scasb
	xchg ax, cx
	je .next
	or bp, _fromall
.callspecific:
	call bubble_handler
	pop si
	pop di
	or si, dx
	or di, bx
	push di
	push si
.next:
	inc cl
	jnz .loop
	pop cx
	pop bx
	or cx, bx
	jnz @F
	mov dx, msg.all_none
	call disp_msg
@@:
	jmp ..@exit


.noint:
	mov dx, msg.bubble.noint
	jmp .abort_msg

.noseg:
	mov dx, msg.bubble.noseg
.abort_msg:
	jmp abort_msg


		; INP:	cl = interrupt number
		;	bp = command line flags
		;	word [cs:matchsegment] = segment to match
		; OUT:	bx = success count
		;	dx = error-or-failure count
		; CHG:	ax, di, si, es, ds
bubble_handler:
	lframe near
	lvar dword, prior
	lvar dword, current
	lvar dword, new
	lvar word, oldivt_fakesig
	lvar dword, oldivt
	lenter
	mov bx, 0FEEBh			; magic value: "jmp short $"
	 push bx
	lvar word, oldivt_fakejmp
	mov word [bp + ?oldivt_fakesig], "VT"	; magic value
%if ?oldivt_fakejmp + ieNext != ?oldivt
 %error Old IVT structure unexpected layout
%endif
%if ?oldivt_fakejmp + ieSignature != ?oldivt_fakesig
 %error Old IVT structure unexpected layout
%endif
	xor bx, bx
	 push bx
	lvar word, foundnonreference
	 push bx
	lvar word, howmany
	 push bx
	lvar word, success
	 push bx
	lvar word, failure

	mov ah, 35h
	mov al, cl
	int 21h

	mov word [bp + ?oldivt + 2], es
	mov word [bp + ?oldivt], bx

@@:
	call checkmatch
	je @F
	call IsIISPEntry?		; that an IISP entry ?
	jnz .top_match_not_found	; nope --> (NZ)
	inc word [bp + ?howmany]
	mov word [bp + ?prior + 2], dx
	mov word [bp + ?prior], bx
	les bx, [es:bx + ieNext]
	jmp @B

@@:
	mov word [bp + ?current + 2], dx
	mov word [bp + ?current], bx
	cmp word [bp + ?howmany], 0	; is it already topmost ?
	je .simple			; no operation needed -->
	testopt [bp + ?frame_bp], _preserve
	jnz .complex			; handle as if not an IISP entry
	call IsIISPEntry?		; that an IISP entry ?
	jnz .complex			; nope --> (NZ)
.normal:	; normal:
		; 1. point IVT to current
		; 2. point prior to current.next
		; 3. point current to oldIVT
	call common2
	mov bx, msg.bubble.table.iisp
	call .display

.common:
		; 1. point IVT to current
		; 2. point prior to current.next/new.next
		; 3. point current/new to oldIVT
	lds dx, [bp + ?current]		; ds:dx -> current
	mov ah, 25h
	int 21h				; 1.
	lds si, [bp + ?new]		; ds:si -> new (IISP)
	mov es, word [bp + ?prior + 2]
	mov di, word [bp + ?prior]	; es:di -> prior (IISP)
	call update_iisp_header		; 2.
	push ds
	pop es				; es => new
	lea di, [si - 6]		; es:di -> new (IISP)
	push ss
	pop ds
	lea si, [bp + ?oldivt - ieNext]	; ds:si -> pseudo IISP of oldIVT
	call update_iisp_header		; 3.

.success:
	inc word [bp + ?success]
.ret:
	pop dx				; ?failure
	pop bx				; ?success
	lleave code
	lret


.display:
	push cx
	push ax
	mov dx, word [cs:bx]
	mov ax, word [cs:actuallength]
	cmp ax, 1
	je @F
	mov dx, word [cs:bx + 2]
	call disp_msg
	call disp_ax_dec
	mov dx, word [cs:bx + 4]
@@:
	call disp_msg
	mov dx, msg.bubble.display.3.singular
	cmp ax, 1
	je @F
	mov dx, msg.bubble.display.3.plural
@@:
	call disp_msg
	pop ax
	push ax
	call disp_al_hex
	mov dx, msg.bubble.2
	mov ax, word [bp + ?current + 2]
	mov cx, word [bp + ?current]
	call .display_int
	mov dx, msg.bubble.4
	call disp_msg
	mov ax, word [bp + ?howmany]
	mov dx, msg.bubble.5.unknown
	cmp ax, -2
	jae @F
	call disp_ax_dec
	mov dx, msg.bubble.5.singular
	cmp ax, 1
	je @F
	mov dx, msg.bubble.5.plural
@@:
	pop ax
	pop cx
	jmp disp_msg

.simple:
	mov dx, msg.bubble.simple.1
	call disp_msg
	call disp_al_hex
	push ax
	push cx
	mov dx, msg.bubble.2
	mov ax, word [bp + ?current + 2]
	mov cx, word [bp + ?current]
	call .display_int
	mov dx, msg.bubble.simple.4
	call disp_msg
	pop cx
	pop ax
	jmp .success

.display_int:
	call disp_msg
	call disp_ax_hex
	mov dx, msg.bubble.3
	call disp_msg
	xchg ax, cx
	jmp disp_ax_hex

.top_match_not_found:
	testopt [bp + ?frame_bp], _complex | _normal
	jnz .fail_match_not_found

	push cx
	mov cx, check_for_reference_to_match
	call searchplex
	pop cx
	jc .fail_match_not_found

	mov word [bp + ?prior + 2], es
	mov word [bp + ?prior], bx
	les bx, [es:bx + ieNext]
	mov word [bp + ?current + 2], es
	mov word [bp + ?current], bx
	call IsIISPEntry?
	jne .fail_match_no_iisp

		; 1. point IVT to current
		; 2. point prior to current.next
		; 3. point current to oldIVT
		; (this is the same as .normal)
	call common2
	mov word [bp + ?howmany], -2
	mov bx, msg.bubble.table.iisp
	call .display
	push ax
	push cx
	mov dx, msg.bubble.complex2.2
	mov ax, word [bp + ?prior + 2]
	mov cx, word [bp + ?prior]
	call .display_int
	mov dx, msg.bubble.complex2.3
	call disp_msg
	pop cx
	pop ax
	jmp .common


.fail_match_no_iisp:
	mov dx, msg.bubble.matchnoiisp.1
	call disp_msg
	call disp_al_hex
	push ax
	push cx
	mov dx, msg.bubble.matchnoiisp.2
	mov ax, word [bp + ?current + 2]
	mov cx, word [bp + ?current]
	call .display_int
	pop cx
	pop ax
	mov dx, msg.bubble.matchnoiisp.3
	jmp .fail_msg

.fail_match_not_found:
	testopt [bp + ?foundnonreference], 1
	jnz @F
	testopt [bp + ?frame_bp], _fromall
	jnz .ret
	mov dx, msg.bubble.matchnotfound.1
	call disp_msg
	call disp_al_hex
	mov dx, msg.bubble.matchnotfound.2
	jmp .fail_msg

@@:
	mov dx, msg.bubble.matchnotref.1
	call disp_msg
	call disp_al_hex
	push ax
	push cx
	mov dx, msg.bubble.matchnotref.2
	mov ax, word [bp + ?current + 2]
	mov cx, word [bp + ?current]
	call .display_int
	pop cx
	pop ax
	mov dx, msg.bubble.matchnotref.3
	jmp .fail_msg

.fail_new_not_found:
	mov dx, msg.bubble.newnotfound.1
	call disp_msg
	call disp_al_hex
	push ax
	push cx
	mov dx, msg.bubble.newnotfound.2
	mov ax, word [bp + ?current + 2]
	mov cx, word [bp + ?current]
	call .display_int
	pop cx
	pop ax
	mov dx, msg.bubble.newnotfound.3
	call disp_msg
	call disp_al_hex
	mov dx, msg.bubble.newnotfound.4
.fail_msg:
	call disp_msg
;.fail:
	inc word [bp + ?failure]
	jmp .ret


.complex:	; complex:
		; find new IISP entry not in IVT-to-current
		; then: (this trail is handled by .common)
		; 1. point IVT to current
		; 2. point prior to new.next
		; 3. point new to oldIVT
	testopt [bp + ?frame_bp], _normal
	jnz .fail_match_not_found

	push cx
	mov cx, checknew
	call searchplex
	pop cx
	jc .fail_new_not_found

		; 1. point IVT to current
		; 2. point prior to new.next
		; 3. point new to oldIVT
	mov bx, msg.bubble.table.noniisp
	call .display
	push ax
	push cx
	mov dx, msg.bubble.complex.2
	mov ax, word [bp + ?new + 2]
	mov cx, word [bp + ?new]
	call .display_int
	mov dx, msg.bubble.complex.3
	call disp_msg
	pop cx
	pop ax

	jmp .common


error_length_too_high: equ $
	mov dx, msg.bubble.lengthtoohigh.1
	call disp_msg
	call disp_al_hex
	push ax
	push cx
	mov dx, msg.bubble.lengthtoohigh.2
	mov ax, word [bp + ?current + 2]
	mov cx, word [bp + ?current]
	call .display_int
	mov dx, msg.bubble.lengthtoohigh.3
	call disp_msg
	mov ax, word [cs:lengthnumber]
	dec ax
	call disp_ax_dec
	pop cx
	pop ax
	mov dx, msg.bubble.lengthtoohigh.4
	jmp .fail_msg


common2:
	push word [bp + ?current + 2]
	push word [bp + ?current]
	pop word [bp + ?new]
	pop word [bp + ?new + 2]	; new = current, no search needed

	mov dx, word [cs:lengthnumber]
	cmp dx, 1
	je .common

	les bx, [bp + ?new]

	and word [cs:actuallength], 0
	cmp dx, -1
	je @FF
	mov word [cs:actuallength], dx

@@:
	call IsIISPEntry?
	jne error_length_too_high
	mov word [bp + ?new + 2], es
	mov word [bp + ?new], bx
	dec dx
	jz .common
	les bx, [es:bx + ieNext]
	jmp @B

@@:
	call IsIISPEntry?
	jne .common
	mov word [bp + ?new + 2], es
	mov word [bp + ?new], bx
	inc word [cs:actuallength]
	les bx, [es:bx + ieNext]
	jmp @B

.common:
	retn


		; INP:	es:bx -> int handler found from multiplexer
		; OUT:	NZ if handler is not a match
		;	ZR if handler is a match
		; CHG:	dx
checkmatch:
	mov dx, es
	testopt [bp + ?frame_bp], _matchsegment
	jz @F
	cmp word [cs:matchoffset], -1
	je .matchsegonly
	cmp bx, word [cs:matchoffset]
	jne @F
.matchsegonly:
	cmp dx, word [cs:matchsegment]
	je .ret
@@:
	testopt [bp + ?frame_bp], _matchmcbname
	jz @F
	push ds
	push es
	push si
	push di
	push ax
	push cx
	push dx

	call getmcbname
	 push ss
	 pop ds
	 push ss
	 pop es
	mov di, word [matchmcbname]
.loop:
	lodsb
	call capitalise
	scasb
	jne .mismatch
	test al, al
	jnz .loop

.mismatch:
	pop dx
	pop cx
	pop ax
	pop di
	pop si
	pop es
	pop ds
	je .ret
@@:
	push ax
	or al, 1		; (NZ)
	pop ax
.ret:
	retn


		; INP:	dx:bx -> int handler
		; OUT:	cs:si -> name, ASCIZ
		; CHG:	dx, ax, cx, di, si, ds, es
		; STT:	cs = ss
getmcbname:
	mov ax, bx
	mov cl, 4
	shr ax, cl
	add ax, dx		; => segment of handler
	jc .hma
	mov dx, word [cs:firstmcb]
.loop:
	mov es, dx
	mov cx, dx
	add cx, word [es:3]
	inc cx
	cmp ax, dx
	jb .next
	cmp ax, cx
	jae .next
	mov dx, word [es:1]
	mov si, msg.di_system_mcb
	cmp dx, 50h
	jb .copy
	dec dx
	mov es, dx
	 push es
	 pop ds
	 push ss
	 pop es
	mov di, mcbnamebuffer
	mov ax, di
	mov si, 8
	mov cx, si
	push di
	rep movsb
	mov al, 0
	stosb			; append zero-value byte
	pop di			; -> name in buffer
	 push ss
	 pop ds
@@:
	scasb			; is it zero ?
	jne @B			; no, continue -->
				; first dec makes it -> at the zero
@@:
	dec di
	cmp ax, di
	je .empty
	cmp byte [di - 1], 32
	je @B
	mov si, mcbnamebuffer
	jmp .ret

.empty:
	dec di
	mov si, msg.di_empty
	jmp .copy

.hma:
	mov si, msg.di_hma
	jmp .copy

.next:
	mov dx, cx
	cmp byte [es:0], "M"
	je .loop

	mov si, msg.di_system_upper
	cmp ax, word [cs:firstumcb]
	ja @F
	mov si, msg.di_system_low
@@:
.copy:
.ret:
	retn


		; INP:	es:bx -> int handler found from multiplexer
		;	di = offset in AMIS interrupt list (if any)
		;	dx = segment of AMIS interrupt list (if any, = es)
		;	ah = multiplex number
		;	al = interrupt number
		;	bubble_handler stack frame
		; OUT:	all INPs preserved
		;	NZ if handler is not a match
		;	ZR if handler is a match,
		;	 es:bx = reference
		; CHG:	es, bx
check_for_reference_to_match:
	push dx

	call checkmatch			; is the very first one a match ?
	jne @F
	mov word [bp + ?current + 2], es
	mov word [bp + ?current], bx
	or byte [bp + ?foundnonreference], 1
					; yes, remember this (no reference to it)
@@:

	db __TEST_IMM16			; (skip 2 pop)
.next:
	pop dx
	pop dx				; (discard reference on stack)
	call IsIISPEntry?		; that an IISP entry ?
	jnz .return			; nope --> (NZ)
	push es
	push bx				; remember reference
	les bx, [es:bx + ieNext]	; get next interrupt entry
	call checkmatch
	jne .next			; no, try next -->
					; yes, found (ZR)
	pop bx
	pop es				; es:bx -> IISP entry with reference
.return:
	pop dx
	retn


		; INP:	es:bx -> int handler found from multiplexer
		;	?oldivt = IVT entry
		;	?howmany = how many handlers to bubble up past
		;	?current = entry to bubble up (end of top chain)
		;	di = offset in AMIS interrupt list (if any)
		;	dx = segment of AMIS interrupt list (if any, = es)
		;	ah = multiplex number
		;	al = interrupt number
		; OUT:	all INPs preserved
		;	NZ if handler is in the top chain we want to relocate
		;	 (or other error condition)
		;	ZR if handler is not in the top chain
		;	 ?new = handler that is useable
		; CHG:	-
checknew:
	push cx
	mov word [bp + ?new + 2], es
	mov word [bp + ?new], bx
	call IsIISPEntry?		; is it IISP ? (useless if not)
	jne .ret			; no --> (NZ)

	les bx, [bp + ?oldivt]		; load pointer from IVT
	xor cx, cx			; initialise counter to zero
.loop:
	mov dx, es
	cmp dx, word [bp + ?new + 2]	; is it our new candidate ?
	jne .checknext
	cmp bx, word [bp + ?new]
	jne .checknext			; no, check next -->
.matched:	; found new in top chain so it is not useable
	or dl, 1			; set NZ
	jmp .ret

.checknext:
	cmp dx, word [bp + ?current + 2]; is it our current (end of top chain) ?
	jne .next
	cmp bx, word [bp + ?current]
	jne .next			; no, loop -->
		; (ZR) reached current, new is valid to use
.ret:
	les bx, [bp + ?new]		; return new handler address
	mov dx, es			;  and restore AMIS interrupt list segment
	pop cx
	retn

.next:
	inc cx				; check that we're still in top chain
	cmp cx, word [bp + ?howmany]
	ja .ret				; (NZ)
	call IsIISPEntry?		; check that it is still IISP
	jne .ret			; (NZ)
	les bx, [es:bx + ieNext]
	jmp .loop


	lleave ctx


		; Search through multiplexer interrupt lists
		;
		; INP:	al = interrupt number
		;	cx = callback
		; OUT:	CY if not found
		;	 ds, si, cx preserved (unless callback changed them)
		;	NC, NZ if found,
		;	 es, di, bx as returned by callback with ZR
		;	 ds, si, cx as returned by callback (may be preserved)
		;	dx, ax preserved
		; CHG:	es, di, bx

		; Callback called with:
		; INP:	es:bx -> entry found from multiplexer (likely IISP)
		;	ds, si, cx preserved from searchplex input
		;	di = offset in AMIS interrupt list (if any)
		;	dx = segment of AMIS interrupt list (if any, = es)
		;	ah = multiplex number
		;	al = interrupt number
		; OUT:	ZR if found (search ends)
		;	NZ if not found (search continues)
		;	 ah = multiplex number (must be preserved)
		;	 al = interrupt number (must be preserved)
		;	 di = offset in AMIS interrupt list (must be preserved)
		;	 dx = segment of AMIS interrupt list (must be preserved)
		;	 search continues in next interrupt list entry,
		;	 or next multiplexer
		;	 ds, si, cx, es, bx passed to searchplex output
		; CHG:	(cx), bx, es, ds, si
searchplex:
	push dx
	push ax				; register with interrupt number last
	xor ax, ax
.loopplex:
	mov al, 00h			; AMIS installation check
	push cx
	int 2Dh				; enquire whether there's anyone
	pop cx				;  but we don't care who it might be
	inc al
	jz .search
.nextplex:
	inc ah
	jnz .loopplex			; try next multiplexer -->
	pop ax
	pop dx
	stc
	retn


		; INP:	ah = multiplex number of AMIS TSR to search through
		;	ss:sp-> interrupt number (byte), must be preserved
		; CHG:	es, di, dx, bx
.search:
	mov al, 04h
	pop bx
	push bx				; low byte is the interrupt number
	int 2Dh
	cmp al, 03h			; returned its interrupt entry ?
				; RBIL doesn't explicitly state that this interrupt entry has to
				; be IISP compatible. But I'm too lazy to look up the older AMIS,
				; and SearchIISPChain checks the interrupt entry anyway.
	je .search_dxbx
	cmp al, 04h			; returned list of hooked interrupts ?
	jne .nextplex			; no, try next multiplexer -->
	mov di, bx
	pop bx
	push bx				; bl = interrupt number
	mov al, bl
.search_intlist_seg:
	mov es, dx			; es:di-> list
.search_intlist:		; Search the returned list for the required interrupt number.
	scasb				; our interrupt number ?
	je .search_found_intlist
	cmp byte [es:di-1], 2Dh		; was last in list ?
	je .nextplex
	scasw				; skip pointer
	jmp short .search_intlist	; try next entry -->
.search_found_intlist:
	mov bx, word [es:di]		; dx:bx-> IISP entry
	scasw				; skip pointer
	call cx
	je .search_found		; found entry -->
		; This specific jump supports TSRs that hook the same
		; interrupt more than once; jumping to .nextplex instead
		; (as previously) aborts the search after the first match
		; in the interrupt list. This support might become useful.
	cmp al, 2Dh			; was last in list ?
	je .nextplex
	jmp short .search_intlist_seg

.search_dxbx:
	mov es, dx			; es:bx-> (IISP) interrupt entry
	pop dx
	push dx
	mov al, dl			; pass interrupt number
				; The entry we found now is possibly behind the non-IISP entry that
				; terminated our first SearchIISPChain call (at .hard). We then
				; possibly might find our entry in this hidden part of the chain.
	call cx
	jne .nextplex			; didn't find our entry in the chain -->
.search_found:
	or al, 1			; NC, NZ
	pop ax
	pop dx
	retn


capitalise:
	cmp al, 'a'
	jb .notlowercase
	cmp al, 'z'
	ja .notlowercase
	and al, ~ 20h		; Uppercase if required
.notlowercase:
	retn


getnybble:
	cmp al, '0'
	jb .invalid		; unknown character -->
	cmp al, '9'
	jbe @F
	call capitalise
	cmp al, 'A'
	jb .invalid
	cmp al, 'F'
	ja .invalid
	sub al, 'A' - 10 - '0'
@@:
	sub al, '0'
	db __TEST_IMM8		; (NC, skip stc)
.invalid:
	stc
	retn


getdecit:
	cmp al, '0'
	jb .invalid		; unknown character -->
	cmp al, '9'
	ja .invalid
	sub al, '0'
	db __TEST_IMM8		; (NC, skip stc)
.invalid:
	stc
	retn


		; INP:	ds:si -> source IISP header (or pseudo header)
		;	es:di -> destination IISP header
		; OUT:	EI
		;	si and di both incremented by 6
		; CHG:	-
		; STT:	UP
update_iisp_header:
	push ax
	mov ax, word [cs:debuggerfunction]
	test ax, ax			; found the debugger ?
	jz @F				; no -->
	int 2Dh				; call its Update IISP Header function
	cmp al, 0FFh			; supported ?
	pop ax
	je .ret				; yes. done -->
	db __TEST_IMM8			; (skip pop)
@@:
	pop ax				; restore ax, then do manual update
	cli				; try to rest while updating chain
	cmpsw				; skip over first word (entrypoint)
					;  (generally xxEBh or 0EA90h)
	movsw
	movsw				; transfer source ieNext to dest ieNext
	sti
.ret:
	retn


		; INP:	al = interrupt number
		;	ds:si-> interrupt entry
		; OUT:	CY if unhooking failed
		;	NC if unhooking successful
		; CHG:	ah, es, di, si
UnhookInterrupt:
			; UnhookInterruptSim (below) only checks if it's possible to unhook this interrupt.
			; This function really unhooks the interrupt if possible.
			;
			; This is to cover the situation when some of the hooked interrupts can unhook,
			; but some can't. If the uninstaller would start to unhook the interrupts and then
			; catch the interrupt that can't be unhooked the user would end up with a dead TSR
			; that's uninstalled halfway. Very bad.
			;
			; "Simulating" the unhooking first and checking if all interrupts can unhook
			; usually will not return such a state.
	call UnhookInterruptSim
	jc .ret				; bad. --> (CY)
	jz .easy
.hard:
				; "hard" case: UnhookInterruptSim has however already done the work,
				; so the hard case is here indeed easier than the easy case.
	call update_iisp_header		; copies our stored pointer into the other's entry
	clc
	retn
.easy:
	push ds
	push dx
	lds dx, [ si + 2 ]		; get what we stored in the entry
	mov ah, 25h			; easy case - just reset to the value stored
	int 21h				; doesn't alter CF (leaves NC from UnhookInterruptSim) or sets NC
	pop dx
	pop ds
.ret:
	retn

		; INP:	ds:si-> IISP entry
		;	al = interrupt number
		; OUT:	NC if no error (either hard or easy case),
		;	 ZR if easy case,
		;	  ds:si-> our IISP entry, containing stored interrupt
		;	 NZ if hard case,
		;	  ds:si-> our IISP entry
		;	  es:di-> IISP entry to modify
		;	CY if error (not first handler and no IISP chain to this handler)
		; CHG:	ah, es, di
UnhookInterruptSim:
	push bx
	mov ah, 35h			; get current vector
	int 21h				; es:bx-> current interrupt handler
	cmp si, bx			; our pointer ?
	jne .hard

	push ax
	push si
	mov si, ds
	mov ax, es
	 cmp si, ax			; our segment ?
	pop si
	pop ax
	jne .hard

	and ah, 00h			; NC, ZR
	pop bx
	retn
.hard:
		; INP:	ds:si-> IISP entry
		;	es:bx-> current interrupt entry
		; OUT:	CY if error
		;	NC, NZ if no error,
		;	 ds:si-> our IISP entry
		;	 es:di-> IISP entry to modify
		; CHG:	ah, es, di, (bx)
	call SearchIISPChain
	jne .harder
.found:				; found reference to our interrupt handler
	mov di, bx			; es:di-> IISP entry that references our's
	or ah, 0FFh			; NC, NZ
	pop bx
	retn

.harder:			; Desperate attempt to find IISP entry that references ours by
				; searching through the interrupts hooked by other AMIS TSRs. Note
				; that the plexer loop will find and search through the list of
				; hooked interrupts of the uninstalling TSR itself, but this causes
				; no trouble.
		; INP:	ds:si-> IISP entry
		; OUT:	CY if error
		;	NC, NZ if no error,
		;	 ds:si-> our IISP entry
		;	 es:di-> IISP entry to modify
		; CHG:	ah, es, di, (bx)
	d4bp
	push dx
	push ax				; register with interrupt number last
	xor ax, ax
.loopplex:
	mov al, 00h			; AMIS installation check
	push cx
	int 2Dh				; enquire whether there's anyone
	pop cx				;  but we don't care who it might be
	inc al
	jz .search
.nextplex:
	inc ah
	jnz .loopplex			; try next multiplexer -->
	pop ax
	pop dx
.fail:					; IISP incompatible TSR between current interrupt entry and our entry
					;  and no AMIS compatible TSR installed on top of our entry
	stc
	pop bx
	retn

		; INP:	ah = multiplex number of AMIS TSR to search through
		;	ss:sp-> interrupt number (byte), must be preserved
		; CHG:	es, di, dx, bx
.search:
	mov al, 04h
	pop bx
	push bx				; low byte is the interrupt number
	int 2Dh
	cmp al, 03h			; returned its interrupt entry ?
				; RBIL doesn't explicitly state that this interrupt entry has to
				; be IISP compatible. But I'm too lazy to look up the older AMIS,
				; and SearchIISPChain checks the interrupt entry anyway.
	je .search_dxbx
	cmp al, 04h			; returned list of hooked interrupts ?
	jne .nextplex			; no, try next multiplexer -->
	mov di, bx
	pop bx
	push bx				; bl = interrupt number
	mov al, bl
.search_intlist_seg:
	mov es, dx			; es:di-> list
.search_intlist:		; Search the returned list for the required interrupt number.
	scasb				; our interrupt number ?
	je .search_found_intlist
	cmp byte [es:di-1], 2Dh		; was last in list ?
	je .nextplex
	scasw				; skip pointer
	jmp short .search_intlist	; try next entry -->
.search_found_intlist:
	mov bx, word [es:di]		; dx:bx-> IISP entry
	scasw				; skip pointer
	call SearchIISPChain
	je .search_found		; found entry -->
		; This specific jump supports TSRs that hook the same
		; interrupt more than once; jumping to .nextplex instead
		; (as previously) aborts the search after the first match
		; in the interrupt list. This support might become useful.
	cmp al, 2Dh			; was last in list ?
	je .nextplex
	jmp short .search_intlist_seg

.search_dxbx:
	mov es, dx			; es:bx-> (IISP) interrupt entry
				; The entry we found now is possibly behind the non-IISP entry that
				; terminated our first SearchIISPChain call (at .hard). We then
				; possibly might find our entry in this hidden part of the chain.
	call SearchIISPChain
	jne .nextplex			; didn't find our entry in the chain -->
.search_found:
	pop ax
	pop dx
	jmp short .found


SearchIISPChain.next:
	les bx, [es:bx +2]		; get next interrupt entry

		; INP:	ds:si-> IISP entry
		;	es:bx-> current interrupt entry
		; OUT:	NZ if reference to ds:si not found in IISP chain es:bx->
		;	ZR if reference found,
		;	 es:bx-> IISP (or uninstalled iHPFS) interrupt entry with reference
		; CHG:	es, bx
SearchIISPChain:
	call IsIISPEntry?			; that an IISP entry ?
	jnz .return				; nope --> (NZ)
	cmp si, word [ es:bx + ieNext ]		; our pointer ?
	jne .next				; no, try next -->
	push ax
	mov ax, ds
	cmp ax, word [ es:bx + ieNext + 2]	; our segment ?
	pop ax
	jne .next				; no, try next -->
.return:					; yes, found (ZR)
	retn


..@exit:				; terminate successful, re-used by some code (install too)
	call restorestate
	mov ax, 4C00h
	int 21h


		; INP:	bx = interrupt number 0..255
		; OUT:	dh = mask, bx = offset into selectedinterrupts
		; CHG:	cl
bx_intnum_to_dh_bx_intsel:
	mov cl, bl
	and cl, 7
	shr bx, 1
	shr bx, 1
	shr bx, 1
	mov dh, 1
	shl dh, cl
	retn


abort_msg:
	call disp_msg
abort:
	call restorestate
	mov ax, 4CFFh
	int 21h


		; This one works similar to UnhookInterruptSim. Here we check that
		; the interrupt currently contains a valid address since we want to
		; chain to the previous handler.
		;
		; INP:	ds:si-> IISP entry
		;	al = interrupt number
		; OUT:	NC if current interrupt handler valid, or we install a non-chaining handler
		;	CY if current interrupt handler invalid (offset FFFFh or segment 0000h)
		; CHG:	ah
HookInterruptSim:
	push es
	push bx
	test byte [ si + ieEOI ], 80h		; should be last handler ?
	jnz .valid				; yes, handler doesn't matter if we don't chain --> (NC)
	mov ah, 35h
	int 21h
	inc bx					; offset FFFFh ?
	jz .error
	mov bx, es
	test bx, bx				; or segment 0000h ?
	jnz .valid				; no, valid --> (NC)
.error:
	stc					; invalid, CY
.valid:
	pop bx
	pop es
	retn


		; INP:	ds:si-> IISP entry
		;	al = interrupt number
		; OUT:	NC if current interrupt handler valid, or we install a non-chaining handler
		;	CY if current interrupt handler invalid (offset FFFFh or segment 0000h),
		;	 though this SHOULD never happen
		; CHG:	ah, es
HookInterrupt:
	call HookInterruptSim
	jc .ret
	push bx
	push dx
	mov ah, 35h
	int 21h					; get current handler
	test byte [ si + ieEOI ], 80h		; should be last handler ?
	jz .notlast
	call IsChainingIISPEntry?		; is the first handler a chaining IISP ?
	jne .notlast				; no, can't hook below it -->
	db __TEST_IMM16				; (skip 2 pop ax)
.loop:
	pop ax
	pop ax					; discard last entry's address
	push es
	push bx
	les bx, [ es:bx + ieNext ]		; load next entry
	call IsChainingIISPEntry?		; this one also a chaining IISP ?
	je .loop
	mov word [ si + ieNext ], bx
	mov word [ si + ieNext + 2 ], es	; store address of next entry (non-IISP or non-chaining)
	pop bx
	pop es
	mov word [ es:bx + ieNext ], si
	mov word [ es:bx + ieNext + 2 ], ds	; store our handler's address in this chaining IISP entry
	jmp short .return

.notlast:
	mov word [ si + ieNext ], bx
	mov word [ si + ieNext + 2 ], es	; store
	mov ah, 25h
	mov dx, si				; ds:dx-> interrupt entry
	int 21h					; set new handler
.return:
	pop dx
	pop bx
	clc
.ret:
	retn


		; INP:	es:bx-> interrupt entry
		; OUT:	NZ if non-IISP entry,
		;	 or IISP entry that doesn't chain
		;	ZR if IISP entry that chains
IsChainingIISPEntry?:
	test byte [ es:bx + ieEOI ], 80h	; this one a non-chaining handler ? (or non-IISP)
	jnz IsIISPEntry?.return			; yes -->
						; otherwise fall through to check if really an IISP entry

		; INP:	es:bx-> interrupt entry
		; OUT:	NZ if non-IISP entry
		;	ZR if IISP entry
IsIISPEntry?:
	cmp bx, - (ieSignature + 2)		; may access word at offset FFFFh ?
	ja .return				; yes, avoid --> (NZ)
	cmp word [ es:bx + ieSignature ], "KB"	; "KB"/424Bh ? ("BK" in MASM)
	jne .return
	cmp word [ es:bx + ieEntry ], 0EA90h	; nop\jmp far imm16:imm16 ?
	je .return				; unused IISP entry (created by iHPFS) -->
	cmp byte [ es:bx + ieEntry ], 0EBh	; jmp short ... ?
		; (This opcode should strictly be jmp short $+18 but there's programs
		; that save an additional jmp opcode by jumping directly into their
		; code even though it's not right behind the header.)
	jne .return
	cmp byte [ es:bx + ieJmphwreset ], 0EBh	; jmp short ... ?
	je .return				; usual IISP entry -->
	cmp byte [ es:bx + ieJmphwreset ], 0CBh	; retf ?
	je .return				; a shorter variant -->
	cmp byte [ es:bx + ieJmphwreset ], 0CFh	; iret ?
.return:
	retn


i24:
	mov al, 3			; always return fail, to handle the error as a soft one
	iret

i23:
	mov word [ cs:$ ], (__JMP_REL8|__REL16__(.return)<<8)	; don't reenter
	call restorestate
.return:
	stc				; always abort program (what default DOS handler also does)
retf_inst:
	retf

		; Restore modified DOS data
		;
		; CHG:	-
		; USE:	Int21
restorestate:
	push ax
	push bx
	mov bx, word [ cs:restored.strategy ]
	mov ax, 5801h
	int 21h				; restore strategy

	mov bx, word [ cs:restored.umblink ]
	mov ax, 5803h
	int 21h				; restore UMB link
	pop bx
	pop ax
	retn


disp_msg:
	 push ds
	 push ax
	push cs
	pop ds
	mov ah, 09h
	int 21h
	 pop ax
	 pop ds
	retn


disp_ax_hex:
	xchg al, ah
	call disp_al_hex
	xchg al, ah
disp_al_hex:
		push cx
		mov cl, 4
		ror al, cl
		call .nibble
		ror al, cl
		pop cx
.nibble:
		push ax
		and al, 0Fh
		add al, '0'
		cmp al, '9'
		jbe .isdigit
		add al, 'A'-('9'+1)
.isdigit:
		xchg dl, al
		mov ah, 02h
		int 21h
		pop ax
		retn


	; Following call: Display number in ax decimal
	; all registers preserved except dx
disp_ax_dec:			; ax (no leading zeros)
	; In: number in ax
	; Out: displayed
		push bx
		xor bx, bx
.pushax:
		push ax
.pushend:
		or bl, bl
		jz .nobl
		sub bl, 5
		neg bl
.nobl:
		push cx
		mov cx, 10000
		call .divide_out
		mov cx, 1000
		call .divide_out
		mov cx, 100
		call .divide_out
		mov cl, 10
		call .divide_out
							; (Divisor 1 is useless)
		add al, '0'
		xchg dl, al
		mov ah, 02h
		int 21h
		pop cx
		pop ax
		pop bx					; Caller's register
		retn

.divide_out:
	; In: ax = number
	;     cx = divisor
	; Out: ax = remainder of operation
	;      result displayed
		push dx
		xor dx, dx
		div cx				; 0:ax / cx
		push dx				; remainder
		dec bl
		jnz .nobl2
		or bh, 1
.nobl2:
		or bh, al
		jz .leadingzero
		add al, '0'
		xchg dl, al
		mov ah, 02h
		int 21h				; display result
 .leadingzero:
		pop ax				; remainder
		pop dx
		retn


	align 2, db 0
firstumcb:	dw 9FFFh			; guess of where UMBs start (A000h+)
firstmcb:	dw 0
restored:
.umblink:	dw 0
.strategy:	dw 0
debuggerfunction:
		dw 0				; = 0 if unused
actuallength:	dw 1
lengthnumber:	dw 1
matchoffset:	dw -1
matchsegment:	dw 0
matchmcbname:	dw 0
matchmcbname_end:
		dw matchmcbname

	align 2, db 0
parameters:			; Valid switches on the command line, followed
				; by a byte with one option flag set.
	db "P", _preserve
	db "N", _normal
	db "C", _complex
	db "B", _bubble
	db "S", _matchsegment
	db "M", _matchmcbname
	db 0FFh			; table end marker
			; The help switches are not in this table (and neither in the option
			; flags) because on invalid switches, we'll show the help anyway.

invalidinterrupts:
	db 1Dh, 1Eh, 1Fh, 22h, 23h, 24h, 30h, 31h
	endarea invalidinterrupts


	align 16, db 0
selectedinterrupts:
	times 32 db 0		; 32 bytes * 8 bit/byte = 256 bits

	align 16, db 0
	endarea transient


debuggeramissig:
amissig:
.ven:	fill 8,32,db "ecm"	; vendor
.prod:	fill 8,32,db "lDebug"	; product
mcbnamebuffer:
		times 9 db 0
msg:
.name:		db "SHUFHOOK: ",36
	%include "messages.asm"

	endarea msg

%if _UPXPAD && (transient_size + msg_size) < 3062
		times (3062 -(transient_size + msg_size))/ 8 db "UPXPAD  "
		times (3062 -(transient_size + msg_size))% 8 db 'U'
%endif
